unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Edit,
  FMX.StdCtrls, FMX.Layouts, FMX.Memo, FMX.Objects, FMX.Effects;

type

  TForm1 = class(TForm)
    Edit1: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    ShadowEffect1: TShadowEffect;
    Label2: TLabel;
    Image1: TImage;
    Image2: TImage;
    Label3: TLabel;
    BlurEffect1: TBlurEffect;
    Panel1: TPanel;
    Button2: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
const
  BateryHealthStr: array [1..7] of string =
    ('unknown', 'Good', 'Overhead', 'Dead', 'Over voltage', 'unspecified failure', 'Cold');
  BateryPluggedStr: array [1..4] of string =
    ('AC plugged', 'USB plugged', 'unknown',  'Wireless plugged');
  BateryStatusStr: array [1..5] of string =
    ('Unknown', 'Charging', 'Discharging', 'Not charging', 'Full');

const
  BATTERY_HEALTH_COLD = 7;
  BATTERY_HEALTH_DEAD = 4;
  BATTERY_HEALTH_GOOD = 2;
  BATTERY_HEALTH_OVERHEAT = 3;
  BATTERY_HEALTH_OVER_VOLTAGE = 5;
  BATTERY_HEALTH_UNKNOWN = 1;
  BATTERY_HEALTH_UNSPECIFIED_FAILURE = 6;

implementation

{$R *.fmx}

uses
  AndroidAPI.JNI.GraphicsContentViewText,
  AndroidAPI.JNI.JavaTypes,
  AndroidAPI.JNI.OS,
  FMX.Platform.Android,
  Androidapi.JNIBridge, Androidapi.Jni,  androidapi.JNI.Net,
  FMX.Helpers.Android;


procedure TForm1.Button1Click(Sender: TObject);
var
  filter: JIntentFilter;
  intentBatt: JIntent;
  iLevel, iScale: Integer;
  i:Integer;
  Str:JString;
  b:boolean;
  myContext: JContext;
begin
  // Contexto
  myContext := SharedActivityContext;

  // Creamos y Configuramos el Intent
  filter := TJIntentFilter.Create;
  // Asociamos la ACTION que queremos capturar
  filter.addAction(TJIntent.JavaClass.ACTION_BATTERY_CHANGED);
  // lo registramos
  intentBatt := myContext.registerReceiver(nil, filter);


  Memo1.Lines.Clear;

  // health
  i := intentBatt.getIntExtra(StringToJString('health'), -1);
  Memo1.Lines.Add('Salut: ' + BateryHealthStr[i]);
  // Icon
  //  i := battery.getIntExtra(StringToJString('icon-smal'), -1);
  //  Memo1.Lines.Add('icon-smal: ' + IntToStr(i));
  // Nivel de batera
  iLevel := intentBatt.getIntExtra(StringToJString('level'), -1);
  Memo1.Lines.Add('Level: ' + IntToStr(iLevel));
  // Plugged
  i := intentBatt.getIntExtra(StringToJString('plugged'), -1);
  Memo1.Lines.Add('Enchufado: ' + BateryPluggedStr[i]);
  // battery present
  b := intentBatt.getBooleanExtra(StringToJString('present'), False);
  Memo1.Lines.Add('Presente: ' + BoolToStr(b, True));
  // Escala para medir el nivel
  iScale := intentBatt.getIntExtra(StringToJString('scale'), -1);
  Memo1.Lines.Add('Escala: ' + IntToStr(iScale));
  // status de la batera
  i := intentBatt.getIntExtra(StringToJString('status'), -1);
  Memo1.Lines.Add('Estado: ' + BateryStatusStr[i]);
  // tecnologa de la batera
  Str := intentBatt.getStringExtra(StringToJString('technology'));
  Memo1.Lines.Add('Tecnologa: ' + JStringToString(Str));
  // Temperatura (en dcimas de grado)
  i := intentBatt.getIntExtra(StringToJString('temperature'), -1);
  Memo1.Lines.Add('Temperatura: ' + FloatToStr(i / 10) + '');
  // Voltage (en MILIVOLTIOS)
  i := intentBatt.getIntExtra(StringToJString('voltage'), -1);
  Memo1.Lines.Add('Voltaje: ' + FloatToStr(i/1000) + ' v.');

  // Mostramos la escala en el form
  i := (100 * iLevel) div iScale;
  Edit1.Text := IntToStr(i) + '%';
  // Modificar la imagen  (0..1)
  Image2.Scale.X := (i / 100);


end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Button1Click(nil);
end;


procedure TForm1.Button4Click(Sender: TObject);
var
  Intent: JIntent;
begin
  // Navegar
  Intent := TJIntent.Create;
  Intent.setAction(TJIntent.JavaClass.ACTION_VIEW);
  Intent.setData(StrToJURI('http://neftali.clubdelphi.com'));
  SharedActivity.startActivity(Intent);

end;

end.
